export { C as CompletionBuilder, c as completion } from './completion.builder-B8qFKZpJ.js';
import { L as Llm } from './llm.types-C70OLa4M.js';
import { Text } from '@synstack/text';
import '@synstack/resolved';
import 'zod';

interface Base64Data {
    type: "base64";
    data: string;
    mimeType: string;
}

declare const userMsg: <T extends Array<MessageTemplate.User.TemplateValue> = MessageTemplate.User.TemplateValue[]>(template: TemplateStringsArray, ...values: T) => Llm.User.Message | Promise<Llm.User.Message>;
declare const assistantMsg: <T extends Array<MessageTemplate.Assistant.TemplateValue> = MessageTemplate.Assistant.TemplateValue[]>(template: TemplateStringsArray, ...values: T) => Llm.Assistant.Message | Promise<Llm.Assistant.Message>;
declare namespace MessageTemplate {
    type Fn<TExtraValue extends Text.ExtraObject.Base = never> = (template: TemplateStringsArray, ...values: Array<Text.TemplateValue<TExtraValue>>) => void;
    namespace Assistant {
        type ExtraValues = Llm.Message.Content.ToolCall;
        type TemplateValue = Text.TemplateValue<ExtraValues>;
        type Fn = MessageTemplate.Fn<ExtraValues>;
    }
    namespace User {
        type ExtraValues = Base64Data | Llm.Message.Content.ToolResponse;
        type TemplateValue = Text.TemplateValue<ExtraValues>;
        type Fn = MessageTemplate.Fn<ExtraValues>;
    }
}

export { Llm, MessageTemplate, assistantMsg, userMsg };
